/* 
 THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 EITHER EXPRESSED OR IMPLIED,  INCLUDING BUT NOT LIMITED TO THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.

 This code is free for both personal and commercial use,
 but you are expressly forbidden from selling.

 **************************************************************************

 FILE NAME:
   olddel.js

 DESCRIPTION: 
   This script helps with automatic removing of files older than a specific
   limit.
   
 USAGE
   cscript //Nologo olddel.js <path> <days>
   
   <path>: Path to search for the files.
   <days>: Files older than <days> will be deleted by this script.
   
 COPYRIGHT:
   Copyright (c) Vamsoft Ltd. 2003, Peter Karsai (peter.karsai@vamsoft.com).
   All rights reserved.

 NOTES:
   Vamsoft Ltd. does not provide any kind of technical support for this
   script.
   
  **************************************************************************   
/*

  Description:
  Returns the files older than intDays found on path strPath
  
  Parameters:
  strPath: Path to be searched.
  intDays: Number of days.
  
  Return Value: Flat array of files found.
*/
function GetFilesOlderThan(strPath, intDays) {
  // declare
  var arrRes = new Array();
  var dtLowBound = new Date(new Date() - ((new Date("2003/03/20") - new Date("2003/03/19")) * intDays));
  
  // enumerate files
  var fs = new ActiveXObject("Scripting.FileSystemObject");
  var folder = fs.GetFolder(strPath);
  var e = new Enumerator(folder.Files); 
  while(!e.atEnd()) {
    // date?
    if((dtLowBound > e.item().DateLastModified) && (e.item().name.toLowerCase() != "olddel.js")) {
      arrRes[arrRes.length] = e.item().Path;
    }
    e.moveNext();
  }
  return(arrRes);
}

// ===================================================================

// declare
var arrFiles;
var strError = "";
var strReport = "";
    
// do our job
if(WScript.Arguments.length == 2) {
  // get arguments
  strPath = WScript.Arguments(0);
  intDays = WScript.Arguments(1);
  
  // get files
  try {  
    arrFiles = GetFilesOlderThan(strPath, intDays);
  }
  catch(e) {
    strError = "Could not enumate files. Reason: " + e.description;   
  }
  
  // delete files if we can
  if(strError.length == 0) {
    var fs = new ActiveXObject("Scripting.FileSystemObject");
    for(var x = 0; x < arrFiles.length; x++) {
      strReport += (new Date().toLocaleString()) + " * Deleting file: " + arrFiles[x] + "... ";
      try {
        fs.DeleteFile(arrFiles[x], false);
        strReport += "deleted.\r\n";
      }
      catch(e) {
        strReport += "ERROR. Reason: " + e.description + "\r\n";
      }
    }
    if(strReport.length == 0) {
      WScript.Echo("Done, no files were deleted.");
    }
    else {
      WScript.Echo(strReport + "= DONE =.");
    }
  }
}
else {
  strError = "Incorrect number of parameters.";
}

// display error if any
if(strError.length > 0) {
  WScript.Echo("ERROR: " + strError);
}
